#include <stdio.h>
#include "atl.h"
#include "cm.h"

typedef struct _msg {
    char *string_field;
} msg, *msg_ptr;

static IOField msg_field_list[] =
{
    {"string_field", "string", sizeof(char*), 0},
    {NULL, NULL, 0, 0}
};

static void
msg_handler(CManager cm, CMConnection conn, void *msg,
        void *client_data)
{
    printf("%s\n", ((msg_ptr)msg)->string_field);
}

int
main (int argc, char **argv)
{
    CManager cm;
    CMFormat format;
    attr_list contact_list;

    cm = CManager_create();
    CMlisten(cm);
    contact_list = CMget_contact_list(cm);
    printf("Contact list \"%s\"\n", 
           attr_list_to_string(contact_list));
    format = CMregister_format(cm, "hello", 
                               msg_field_list, NULL);
    CMregister_handler(format, msg_handler, NULL);
    CMrun_network(cm);
}
