

#ifndef __CM__H__
#define __CM__H__

#if defined(FUNCPROTO) || defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus)
#ifndef ARGS
#define ARGS(args) args
#endif
#else
#ifndef ARGS
#define ARGS(args) (/*args*/)
#endif
#endif

#ifdef MODULE
#include "../include/io.h"
#include "../include/atl.h"
#else
#include "io.h"
#include "atl.h"
#endif
#ifdef	__cplusplus
extern "C" {
#endif


extern int CM_debug_flag;

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

#ifdef MODULE
#define PERIOD 100

extern int
CMtask_sleep ARGS((int time)); 
extern int
CMtask_kill ARGS((int pid)); 
#endif

typedef struct _CMformat_list {
    char *format_name;
    IOFieldList field_list;
}CMFormatRec, *CMFormatList;

struct _CManager;
struct _CMConnection;
struct _CMFormat;

typedef void (*CMHandlerFunc) ARGS((struct _CManager *, 
				    struct _CMConnection *,
				    void *message, void *client_data));

typedef void (*CMPollFunc) ARGS((struct _CManager *, 
				 void *client_data));

typedef void (*CMCloseHandlerFunc) ARGS((struct _CManager *, 
					 struct _CMConnection *,
					 void *client_data));

typedef struct _CManager *CManager;
typedef struct _CMConnection *CMConnection;
typedef struct _CMFormat *CMFormat;
typedef struct _CMTaskHandle *CMTaskHandle;

//#define MAX_STR 128

typedef struct _syscall_attrs_cm {
    char name[MAX_STR];
    int name_len;
    CManager cm;
    int sec;
    unsigned long func;
    void *event;
    int event_len;
    void *client_data;
    attr_list event_attrs;
}syscall_attrs_cm, *syscall_attrs_cm_ptr;

#ifndef KECHO
extern CManager CManager_create();

extern void CManager_close ARGS((CManager cm));

extern int CMfork_comm_thread ARGS((CManager cm));

extern void *CMtake_buffer ARGS((CManager cm, void *data));
extern void CMreturn_buffer ARGS((CManager cm, void *data));

extern CMConnection
CMget_conn ARGS((CManager cm, attr_list contact_list));

extern CMConnection
CMinitiate_conn ARGS((CManager cm, attr_list contact_list));

extern attr_list
CMConnection_get_attrs ARGS((CMConnection conn));

extern void
CMConnection_close ARGS((CMConnection conn));

extern void
CMConnection_add_reference ARGS((CMConnection conn));

extern int
CMcontact_self_check ARGS((CManager cm, attr_list attrs));

extern attr_list
CMget_contact_list ARGS((CManager cm));

extern CMFormat
CMregister_format ARGS((CManager cm, char *format_name,
		       IOFieldList field_list, CMFormatList format_list));
extern IOFormat
CMregister_user_format ARGS((CManager cm, IOContext context, char *format_name,
			      IOFieldList field_list, CMFormatList format_list));

extern CMFormat CMlookup_format ARGS((CManager cm, IOFieldList field_list));
extern IOFormat CMlookup_user_format ARGS((CManager cm, IOFieldList field_list));

extern IOFormat CMget_IOformat_by_name ARGS((CManager cm, IOContext context,
					     char *name));
extern IOFormat CMget_format_IOcontext ARGS((CManager cm, IOContext context,
					     void *buffer));
extern IOFormat *CMget_subformats_IOcontext ARGS((CManager cm, 
						  IOContext context,
						  void *buffer));
extern void
CMset_conversion_IOcontext ARGS((CManager cm, IOContext context,
				 IOFormat format, IOFieldList field_list,
				 int native_struct_size));

extern
IOContext CMget_user_type_context ARGS((CManager cm));
extern
void CMfree_user_type_context ARGS((CManager cm, IOContext context));

extern int
CMwrite ARGS((CMConnection conn, CMFormat format, void *data));

extern int
CMwrite_attr ARGS((CMConnection conn, CMFormat format, void *data, 
		   attr_list attrs));

extern void
CMregister_handler ARGS((CMFormat format, CMHandlerFunc handler, 
			void *client_data));

extern void
CMconn_register_close_handler ARGS((CMConnection conn, 
				    CMCloseHandlerFunc func, 
				    void *client_data));

typedef void (*CMNonCMHandler) ARGS((struct _CMConnection *,
				     int header));

extern void
CMregister_non_CM_message_handler ARGS((int header, CMNonCMHandler handler));

extern void
CMadd_poll ARGS((CManager cm, CMPollFunc func, void *client_data));

extern CMTaskHandle
CMadd_periodic ARGS((CManager cm, long period, CMPollFunc func,
		     void *client_data));

extern CMTaskHandle
CMadd_periodic_task ARGS((CManager cm, int period_sec, int period_used, 
			  CMPollFunc func, void *client_data));

extern CMTaskHandle
CMadd_delayed_task ARGS((CManager cm, int secs, int usec, CMPollFunc func,
			 void *client_data));

extern void
CMsleep ARGS((CManager cm, int secs));

extern void
CMusleep ARGS((CManager cm, int usecs));

extern void
CMremove_periodic ARGS((CMTaskHandle handle));

extern void
CMremove_task ARGS((CMTaskHandle handle));

#ifdef MODULE
extern 
void initiate_resubmit_buf ARGS((CMConnection conn));
extern 
int CMpoll_network ARGS((CManager cm));
extern 
int CMretrieve_event ARGS((CManager cm));
extern 
void CMevent_delivered ARGS((CManager cm));
extern 
void CMdeliver_event ARGS((CManager cm, void *func, void *cm_event, 
	int cm_event_len, 
	void *client_data, attr_list event_attrs));
#else
extern 
void CMpoll_network ARGS((CManager cm));
#endif

extern 
void CMrun_network ARGS((CManager cm));

int CMCondition_get ARGS((CManager CM, CMConnection dep));
int CMCondition_wait ARGS((CManager CM, int condition));
void CMCondition_signal ARGS((CManager CM, int condition));
void CMCondition_set_client_data ARGS((CManager CM, int condition,
				       void *client_data));
void *CMCondition_get_client_data ARGS((CManager CM, int condition));
int CMCondition_has_signaled ARGS((CManager CM, int condition));
int CMCondition_has_failed ARGS((CManager CM, int condition));

extern void CMget_qual_hostname ARGS((char *buf, int len));
extern int CMlisten ARGS((CManager cm));
extern int CMlisten_specific ARGS((CManager cm, attr_list listen_info));

extern void* CMrealloc ARGS((void *ptr, int size));
extern void* CMmalloc ARGS((int size));
extern void CMfree ARGS((void *ptr));

#else
#include <linux/qfabric.h>

#define MAX_EVENT_SIZE (1<<16)

typedef void (*HandlerFunction) ARGS((void *event, int length, 
	void *client_data, attr_list event_attrs));

syscall_attrs_cm attrs1;
syscall_attrs_cm attrs2;
syscall_attrs_cm attrs3;
syscall_attrs_cm attrs4;

void CMpoll_network(
CManager cm)
{
  char *name = "CMpoll_network";
  char *name2 = "CMretrieve_event";
  HandlerFunction func;

  attrs1.cm = cm;
  memcpy((void *)&attrs1.name, (void *)name, strlen(name)+1);
  attrs1.name_len = strlen(attrs1.name);

  if (KECho_syscall_cm((void *)&attrs1) == 2) {
    memcpy((void *)&attrs1.name, (void *)name2, strlen(name2)+1);
    attrs1.name_len = strlen(attrs1.name);
    attrs1.event = malloc(MAX_EVENT_SIZE);
    while (KECho_syscall_cm((void *)&attrs1) == 0) {
      func = (HandlerFunction)attrs1.func;
      func(attrs1.event, attrs1.event_len, attrs1.client_data, attrs1.event_attrs);
    }
    free(attrs1.event);
  }

  return;
}

CManager CManager_create() 
{ 
  char *name = "CManager_create";

  memcpy((void *)&attrs2.name, (void *)name, strlen(name)+1);
  attrs2.name_len = strlen(attrs2.name);

  KECho_syscall_cm((void *)&attrs2);

  return attrs2.cm;
}

void CMrun_network (
CManager cm)
{
  char *name = "CMrun_network";

  attrs3.cm = cm;
  memcpy((void *)&attrs3.name, (void *)name, strlen(name)+1);
  attrs3.name_len = strlen(attrs3.name);

  KECho_syscall_cm((void *)&attrs3);
}

void CMsleep(
CManager cm,
int sec)
{
  char *name = "CMsleep";

  attrs4.cm = cm;
  attrs4.sec = sec;
  memcpy((void *)&attrs4.name, (void *)name, strlen(name)+1);
  attrs4.name_len = strlen(attrs4.name);

  KECho_syscall_cm((void *)&attrs4);
}

#endif

             
#ifdef	__cplusplus
}
#endif

#endif
