/* $Id: echo.h,v 1.11 2001/04/03 16:07:36 eisen Exp $ */
/* This is the include file for dataexchange */


#ifndef __ECHO__H__
#define __ECHO__H__

#ifdef MODULE
#include "../include/io.h"
#include "../include/cm.h"
#else
#include "io.h"
#include "cm.h"
#endif

#if defined(FUNCPROTO) || defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus)
#ifndef ARGS
#define ARGS(args) args
#endif
#else
#ifndef ARGS
#define ARGS(args) (/*args*/)
#endif
#endif

/* Channel functions */

typedef struct _EControlContext *EControlContext;
typedef struct _EChannel *EChannel;
typedef struct _ECSourceHandle *ECSourceHandle;
typedef struct _ECSinkHandle *ECSinkHandle;
typedef struct _ECDataHandle *ECDataHandle;
typedef struct _ECMultiEventQueue *ECEventQueueList;
typedef struct _ECEventRec *ECEventRec;
typedef struct _ECRealTimeAttrs {
    int rt_header[2];
    struct timeval timestamp;
    struct timeval deadline;
    struct timeval est;
    struct timeval lst;
    struct timeval period;
    int priority;
    int type; /* 1=reuse, 0=1shot */
}ECRealTimeAttrsStruct, *ECRealTimeAttrs;
typedef struct _ECRealTimeAttrs ECRTAttrs;

extern void power_bp(int adjustment);

typedef void (*ECHandlerFunction) ARGS((void *event, int length,
					void *client_data, attr_list event_attrs));

typedef void (*ECTypedHandlerFunction) ARGS((void *event, void *client_data, attr_list event_attrs));

typedef void (*ECMultiHandlerFunction) ARGS((ECEventQueueList event_queues, 
					     void *client_data));

typedef void (*ECSubscribeFunction) ARGS((int subscribe, int subscriber_count,
					  void *client_data));

typedef void (*EventFreeFunction) ARGS((void *event_data));

typedef void (*ECRequestHandlerFunction) ARGS((ECSourceHandle handle, 
					       void *client_data));

typedef struct _ECMultiSubscribeList {
    EChannel channel;
    IOFieldList field_list;
    CMFormatList subformat_list;
}ECMultiSubscribeList, *ECMultiSubscribePtr;

#define MAX_STR 256

typedef struct _syscall_attrs {
    char name[MAX_STR];
    int name_len;
    char conn_id[MAX_STR];
    int conn_id_len;
    CManager cm;
    attr_list attrs;
    EControlContext ec;
    EChannel chan;
    char chan_id[MAX_STR];
    char global_name[MAX_STR];
    ECSourceHandle source_handle;
    void *event;
    int event_len;
    ECHandlerFunction func;
    void *client_data;
    IOFieldList field_list;
    CMFormatList format_list;
    char event_filter[MAX_STR];
    ECSinkHandle sink_handle;
    ECDataHandle data_handle;
    void *data;
    char proto_id[MAX_STR];
    char filter_function[MAX_STR];
    int period;
    char *ret_string;
    struct _ECRealTimeAttrs rt_attrs;
}syscall_attrs, *syscall_attrs_ptr;

#ifndef KECHO
extern EControlContext ECho_CM_init ARGS((CManager cm));

extern EChannel
 EChannel_create ARGS((EControlContext ec));

extern EChannel
 EChannel_create_id ARGS((EControlContext ec, char *conn_id));

extern EChannel
 EChannel_create_attr ARGS((EControlContext ec, attr_list attrs));

extern EChannel
 EChannel_create_attr_id ARGS((EControlContext ec, attr_list attrs, char *conn_id));

extern void
 EChannel_destroy ARGS((EChannel chan));

extern EChannel
EChannel_typed_create ARGS((EControlContext ec, IOFieldList field_list,
			    CMFormatList format_list));

extern EChannel
 EChannel_open ARGS((EControlContext ec, char *global_name));

extern EChannel
 EChannel_open_id ARGS((EControlContext ec, char *global_name, char *conn_id));

extern EChannel
EChannel_derive ARGS((EControlContext ec, char *chan_id, char *event_filter));

extern EChannel
EChannel_create_filtered ARGS((EControlContext ec, char *chan_id,
			       char *event_filter));

extern EChannel
EChannel_create_filtered_id ARGS((EControlContext ec, char *chan_id,
			       char *event_filter, char *conn_id));

extern EChannel
EChannel_typed_derive ARGS((EControlContext ec, char *chan_id, char *event_filter,
			    IOFieldList field_list, CMFormatList format_list));

extern EChannel
EChannel_create_transformed ARGS((EControlContext ec, char *chan_id, 
				  char *event_xform, IOFieldList field_list,
				  CMFormatList format_list));

extern EChannel
EChannel_create_transformed_id ARGS((EControlContext ec, char *chan_id, 
				  char *event_xform, IOFieldList field_list,
				  CMFormatList format_list, char *conn_id));

extern char *
EChannel_remote_filter ARGS((EControlContext ec, char *remote_contact_list, 
			     char *src_chan_id, char *event_filter));

extern char *
EChannel_remote_transform ARGS((EControlContext ec, 
				char *remote_contact_list, 
				char *src_chan_id, char *event_filter, 
				IOFieldList field_list, 
				CMFormatList format_list));

extern char *ECglobal_id ARGS((EChannel chan));

extern void
EChannel_subscribe_handler ARGS((EChannel chan, ECSubscribeFunction func,
				 void *client_data));

#ifdef MODULE
extern void
add_to_channel_pool ARGS((EChannel chan));
#endif

#ifdef MODULE
extern void *
ECset_rt_attributes ARGS((ECSourceHandle handle, ECRealTimeAttrs rtattrs));

#endif

#ifdef MODULE
extern void *
#else
extern void
#endif
ECsubmit_event ARGS((ECSourceHandle handle, void *event, int event_length));

#ifdef MODULE
extern void *
#else
extern void
#endif
ECsubmit_typed_event ARGS((ECSourceHandle handle, void *event));

extern void
ECrequest_event ARGS((ECSinkHandle handle, int req_try));

#ifdef MODULE
extern void *
#else
extern void
#endif
ECsubmit_eventV ARGS((ECSourceHandle handle, IOEncodeVector eventv));

#ifdef MODULE
extern void *
#else
extern void
#endif
ECsubmit_general_event ARGS((ECSourceHandle handle, void *event,
			     int event_len, EventFreeFunction free_func));

#ifdef MODULE
extern void *
#else
extern void
#endif
ECsubmit_general_typed_event ARGS((ECSourceHandle handle, void *event,
				   EventFreeFunction free_func));

#ifdef MODULE
extern void *
#else
extern void
#endif
ECsubmit_general_eventV ARGS((ECSourceHandle handle, IOEncodeVector eventV,
			      EventFreeFunction free_func));

#ifdef MODULE
extern void *
ECsubmit_event_attr ARGS((ECSourceHandle handle, void *event, int event_length,
	attr_list attrs));
extern void *
ECsubmit_typed_event_attr ARGS((ECSourceHandle handle, void *event,
	attr_list attrs));
extern void *
ECsubmit_eventV_attr ARGS((ECSourceHandle handle, IOEncodeVector eventv,
	attr_list attrs));
extern void *
ECsubmit_general_event_attr ARGS((ECSourceHandle handle, void *event,
			     int event_len, EventFreeFunction free_func,
			     attr_list attrs));
extern void *
ECsubmit_general_typed_event_attr ARGS((ECSourceHandle handle, void *event,
				   EventFreeFunction free_func, attr_list attrs));
extern void *
ECsubmit_general_eventV_attr ARGS((ECSourceHandle handle, IOEncodeVector eventV,
			      EventFreeFunction free_func, attr_list attrs));

extern int 
ECregister_channel_filter ARGS((char *module_name, void *out_filter, void *in_filter));
extern void
ECunregister_channel_filter ARGS((int id));

extern int
ECget_num_members ARGS((EChannel chan, int type));

extern void
ECset_link_attrs ARGS((EChannel chan, char *ptr, int index, int type));

extern char *
ECget_link_attrs ARGS((EChannel chan, int index, int type));

extern char *
ECget_link_id ARGS((EChannel chan, int index, int type));

extern void
ECset_link_block ARGS((EChannel chan, int index, int type, int block));

extern ECSinkHandle
 ECsink_subscribe_filter ARGS((EChannel chan, ECHandlerFunction func, 
	void *client_data, char *filter));

extern ECSinkHandle
 ECsink_typed_subscribe_filter ARGS((EChannel chan, IOFieldList field_list,
			      CMFormatList format_list,
			      ECTypedHandlerFunction func, void *client_data,
				char *filter));

extern ECSourceHandle
 ECsource_subscribe_filter ARGS((EChannel chan, char *filter));

extern ECSourceHandle
 ECsource_typed_subscribe_filter ARGS((EChannel chan, IOFieldList field_list,
				CMFormatList format_list, char *filter));
#endif

extern ECSinkHandle
 ECsink_subscribe ARGS((EChannel chan, ECHandlerFunction func, void *client_data));

extern ECSinkHandle
 ECsink_subscribe_context ARGS((EChannel chan, ECHandlerFunction func,
				void *client_data, EControlContext ec));

extern ECSinkHandle
 ECsink_typed_subscribe ARGS((EChannel chan, IOFieldList field_list,
			      CMFormatList format_list,
			      ECTypedHandlerFunction func, void *client_data));

extern ECSinkHandle
 ECsink_multi_subscribe ARGS((ECMultiSubscribePtr sink_specs,
			      EControlContext ec,
			      ECMultiHandlerFunction func, 
			      void *client_data));

extern ECSinkHandle
 ECsink_typed_subscribe_context ARGS((EChannel chan, IOFieldList field_list,
				      CMFormatList format_list,
				      ECTypedHandlerFunction func,
				      void *client_data, EControlContext ec));

extern ECSourceHandle
 ECsource_subscribe ARGS((EChannel chan));

extern ECSourceHandle
 ECsource_typed_subscribe ARGS((EChannel chan, IOFieldList field_list,
				CMFormatList format_list));

extern ECSourceHandle
 ECPsource_subscribe ARGS((EChannel chan, 
			   ECRequestHandlerFunction func, void *client_data));

extern ECSourceHandle 
  ECPsource_typed_subscribe ARGS((EChannel chan, IOFieldList field_list, 
				  CMFormatList format_list, 
				  ECRequestHandlerFunction func, void *client_data));

extern void
ECcancel_sink_subscribe ARGS((ECSinkHandle handle));

extern void
ECcancel_source_subscribe ARGS((ECSourceHandle handle));

extern int EChas_sinks ARGS((ECSourceHandle handle));

extern IOFieldList EChannel_get_field_list ARGS((EChannel chan));
extern CMFormatList EChannel_get_format_list ARGS((EChannel chan));

extern void ECdump_typed_event_as_XML ARGS((EChannel chan, void* event));
extern void ECdump_event_as_XML ARGS((EChannel chan, void* event));

typedef struct _ECdata_struct {
    IOFieldList data_field_list;
    CMFormatList data_subformat_list;
    void *initial_value;
}ECdata_struct, *ECdata_spec;

typedef struct _ECproto *ECproto;

#ifdef __ECL__H__
extern ECproto ECproto_create ARGS((EControlContext ec, ecl_parse_context context));
#endif
extern char *ECproto_id ARGS((ECproto proto_chan));

extern EChannel 
ECproto_derive_periodic ARGS((EControlContext ec, char *proto_id, 
			      char *filter_function,
			      IOFieldList field_list, CMFormatList format_list,
			      int microsec_period));

extern EChannel 
EChannel_derive_data ARGS((EControlContext ec, char *chan_id, 
			   char *filter_function, 
			   ECdata_spec data_spec));
extern EChannel 
EChannel_typed_derive_data ARGS((EControlContext ec, char *chan_id,
				 char *filter_function,
				 IOFieldList field_list, 
				 CMFormatList format_list,
				 ECdata_spec data_spec));

extern ECDataHandle 
EChannel_data_open ARGS((EChannel channel, IOFieldList data_field_list,
			 CMFormatList data_subformat_list));
extern void 
EChannel_data_update ARGS((ECDataHandle data_handle, void *data));

extern void
EChannel_data_close ARGS((ECDataHandle handle));

extern ECEventRec
ECQget_event_rec ARGS((ECEventQueueList list, int queue_number,
		       int event_number));

extern void *
ECEvent_get_ptr ARGS((ECEventRec event_rec));

extern int
ECtake_event_buffer ARGS((EControlContext ec, void *event));

extern void
ECreturn_event_buffer ARGS((EControlContext ec, void *event));

#else
#include <linux/qfabric.h>

syscall_attrs eattrs1;
syscall_attrs eattrs2;
syscall_attrs eattrs3;
syscall_attrs eattrs4;
syscall_attrs eattrs5;
syscall_attrs eattrs6;
syscall_attrs eattrs7;
syscall_attrs eattrs8;
syscall_attrs eattrs9;
syscall_attrs eattrs10;
syscall_attrs eattrs11;
syscall_attrs eattrs12;
syscall_attrs eattrs13;
syscall_attrs eattrs14;
syscall_attrs eattrs15;
syscall_attrs eattrs16;
syscall_attrs eattrs17;
syscall_attrs eattrs18;
syscall_attrs eattrs19;
syscall_attrs eattrs20;
syscall_attrs eattrs21;
syscall_attrs eattrs22;

EControlContext ECho_CM_init (
CManager cm)
{
  char *name = "ECho_CM_init";

  eattrs1.cm = cm;
  memcpy((void *)&eattrs1.name, name, strlen(name)+1);
  eattrs1.name_len = strlen(eattrs1.name);

  KECho_syscall_echo((void *) &eattrs1);

  return eattrs1.ec; 
}

EChannel EChannel_create (
EControlContext ec)
{
  char *name = "EChannel_create";

  eattrs2.ec = ec;
  memcpy((void *)&eattrs2.name, name, strlen(name)+1);
  eattrs2.name_len = strlen(eattrs2.name);

  KECho_syscall_echo((void *) &eattrs2);

  return eattrs2.chan;
}

EChannel EChannel_create_id (
EControlContext ec, char *conn_id)
{
  char *name = "EChannel_create_id";

  eattrs2.ec = ec;
  memcpy((void *)&eattrs2.name, name, strlen(name)+1);
  eattrs2.name_len = strlen(eattrs2.name);
  memcpy((void *)&eattrs2.conn_id, conn_id, strlen(conn_id)+1);
  eattrs2.conn_id_len = strlen(eattrs2.conn_id);

  KECho_syscall_echo((void *) &eattrs2);

  return eattrs2.chan;
}

EChannel EChannel_create_attr (
EControlContext ec,
attr_list kattrs)
{
  char *name = "EChannel_create_attr";

  eattrs3.ec = ec;
  eattrs3.attrs = kattrs;
  memcpy((void *)&eattrs3.name, name, strlen(name)+1);
  eattrs3.name_len = strlen(eattrs3.name);

  KECho_syscall_echo((void *) &eattrs3);

  return eattrs3.chan;
}

EChannel EChannel_create_attr_id (
EControlContext ec,
attr_list kattrs, char *conn_id)
{
  char *name = "EChannel_create_attr";

  eattrs3.ec = ec;
  eattrs3.attrs = kattrs;
  memcpy((void *)&eattrs3.name, name, strlen(name)+1);
  eattrs3.name_len = strlen(eattrs3.name);
  memcpy((void *)&eattrs3.conn_id, conn_id, strlen(conn_id)+1);
  eattrs3.conn_id_len = strlen(eattrs3.conn_id);

  KECho_syscall_echo((void *) &eattrs3);

  return eattrs3.chan;
}

char *ECglobal_id (
EChannel chan)
{
  char *name = "ECglobal_id";

  eattrs4.chan = chan;
  memcpy((void *)&eattrs4.name, name, strlen(name)+1);
  eattrs4.name_len = strlen(eattrs4.name);

  KECho_syscall_echo((void *) &eattrs4);

  return eattrs4.ret_string;
}

EChannel EChannel_open (
EControlContext ec,
char *global_name)
{
  char *name = "EChannel_open";

  eattrs5.ec = ec;
  memcpy((void *)&eattrs5.global_name, global_name, strlen(global_name)+1);
  memcpy((void *)&eattrs5.name, name, strlen(name)+1);
  eattrs5.name_len = strlen(eattrs5.name);

  KECho_syscall_echo((void *) &eattrs5);
	
  return eattrs5.chan;
}

EChannel EChannel_open_id (
EControlContext ec,
char *global_name,
char *conn_id)
{
  char *name = "EChannel_open_id";

  eattrs5.ec = ec;
  memcpy((void *)&eattrs5.global_name, global_name, strlen(global_name)+1);
  memcpy((void *)&eattrs5.name, name, strlen(name)+1);
  eattrs5.name_len = strlen(eattrs5.name);
  memcpy((void *)&eattrs5.conn_id, conn_id, strlen(conn_id)+1);
  eattrs5.conn_id_len = strlen(eattrs5.conn_id);

  KECho_syscall_echo((void *) &eattrs5);
	
  return eattrs5.chan;
}

ECSourceHandle ECsource_subscribe (
EChannel chan)
{
  char *name = "ECsource_subscribe";

  eattrs6.chan = chan;
  memcpy((void *)&eattrs6.name, name, strlen(name)+1);
  eattrs6.name_len = strlen(eattrs6.name);

  KECho_syscall_echo((void *) &eattrs6);

  return eattrs6.source_handle;
}

ECSourceHandle ECsource_subscribe_filter (
EChannel chan,
char *fname)
{
  char *name = "ECsource_subscribe_filter";

  eattrs7.chan = chan;
  memcpy((void *)&eattrs7.filter_function, fname, strlen(fname)+1);
  memcpy((void *)&eattrs7.name, name, strlen(name)+1);
  eattrs7.name_len = strlen(eattrs7.name);

  KECho_syscall_echo((void *) &eattrs7);

  return eattrs7.source_handle;
}

void ECsubmit_event (
ECSourceHandle handle,
void *event,
int event_length)
{
  char *name = "ECsubmit_event";

  eattrs8.source_handle = handle;
  eattrs8.event = event;
  eattrs8.event_len = event_length;
  memcpy((void *)&eattrs8.name, name, strlen(name)+1);
  eattrs8.name_len = strlen(eattrs8.name);

  KECho_syscall_echo((void *) &eattrs8);

  CMpoll_network(eattrs8.cm);
}

void ECset_rt_attributes (
ECSourceHandle handle,
ECRealTimeAttrs rt_attrs)
{
  char *name = "ECset_rt_attributes";

  eattrs22.source_handle = handle;
  memcpy((void *)&eattrs22.rt_attrs, rt_attrs, sizeof(struct _ECRealTimeAttrs));
  memcpy((void *)&eattrs22.name, name, strlen(name)+1);
  eattrs22.name_len = strlen(eattrs22.name);

  KECho_syscall_echo((void *) &eattrs22);
}

ECSinkHandle ECsink_subscribe (
EChannel chan,
ECHandlerFunction func,
void *client_data)
{
  char *name = "ECsink_subscribe";

  eattrs9.chan = chan;
  eattrs9.func = func;
  eattrs9.client_data = client_data;
  memcpy((void *)&eattrs9.name, name, strlen(name)+1);
  eattrs9.name_len = strlen(eattrs9.name);

  KECho_syscall_echo((void *) &eattrs9);

  return eattrs9.sink_handle;
}

ECSinkHandle ECsink_subscribe_filter (
EChannel chan,
ECHandlerFunction func,
void *client_data,
char *fname)
{
  char *name = "ECsink_subscribe_filter";

  eattrs10.chan = chan;
  eattrs10.func = func;
  eattrs10.client_data = client_data;
  memcpy((void *)&eattrs10.name, name, strlen(name)+1);
  memcpy((void *)&eattrs10.filter_function, fname, strlen(fname)+1);
  eattrs10.name_len = strlen(eattrs10.name);

  KECho_syscall_echo((void *) &eattrs10);

  return eattrs10.sink_handle;
}

EChannel EChannel_typed_create (
EControlContext ec,
IOFieldList field_list,
CMFormatList format_list)
{
  char *name = "EChannel_typed_create";

  eattrs11.ec = ec;
  eattrs11.field_list = field_list;
  eattrs11.format_list = format_list;
  memcpy((void *)&eattrs11.name, name, strlen(name)+1);
  eattrs11.name_len = strlen(eattrs11.name);

  KECho_syscall_echo((void *) &eattrs11);

  return eattrs11.chan;
}

ECSourceHandle ECsource_typed_subscribe (
EChannel chan,
IOFieldList field_list,
CMFormatList format_list)
{
  char *name = "ECsource_typed_subscribe";

  eattrs12.chan = chan;
  eattrs12.field_list = field_list;
  eattrs12.format_list = format_list;
  memcpy((void *)&eattrs12.name, name, strlen(name)+1);
  eattrs12.name_len = strlen(eattrs12.name);

  KECho_syscall_echo((void *) &eattrs12);

  return eattrs12.source_handle;
}

ECSourceHandle ECsource_typed_subscribe_filter (
EChannel chan,
IOFieldList field_list,
CMFormatList format_list,
char *fname)
{
  char *name = "ECsource_typed_subscribe_filter";

  eattrs13.chan = chan;
  eattrs13.field_list = field_list;
  eattrs13.format_list = format_list;
  memcpy((void *)&eattrs13.name, name, strlen(name)+1);
  memcpy((void *)&eattrs13.filter_function, fname, strlen(fname)+1);
  eattrs13.name_len = strlen(eattrs13.name);

  KECho_syscall_echo((void *) &eattrs13);

  return eattrs13.source_handle;
}

void ECsubmit_typed_event (
ECSourceHandle handle,
void *event)
{
  char *name = "ECsubmit_typed_event";

  eattrs14.source_handle = handle;
  eattrs14.event = event;
  memcpy((void *)&eattrs14.name, name, strlen(name)+1);
  eattrs14.name_len = strlen(eattrs14.name);

  KECho_syscall_echo((void *) &eattrs14);
}

ECSinkHandle ECsink_typed_subscribe (
EChannel chan,
IOFieldList field_list,
CMFormatList format_list,
ECTypedHandlerFunction func,
void *client_data)
{
  char *name = "ECsink_typed_subscribe";

  eattrs15.chan = chan;
  eattrs15.field_list = field_list;
  eattrs15.format_list = format_list;
  eattrs15.func = (void *)func;
  eattrs15.client_data = client_data;
  memcpy((void *)&eattrs15.name, name, strlen(name)+1);
  eattrs15.name_len = strlen(eattrs15.name);

  KECho_syscall_echo((void *) &eattrs15);

  return eattrs15.sink_handle;
}

ECSinkHandle ECsink_typed_subscribe_filter (
EChannel chan,
IOFieldList field_list,
CMFormatList format_list,
ECTypedHandlerFunction func,
void *client_data,
char *fname)
{
  char *name = "ECsink_typed_subscribe_filter";

  eattrs16.chan = chan;
  eattrs16.field_list = field_list;
  eattrs16.format_list = format_list;
  eattrs16.func = (void *)func;
  eattrs16.client_data = client_data;
  memcpy((void *)&eattrs16.name, name, strlen(name)+1);
  memcpy((void *)&eattrs16.filter_function, fname, strlen(fname)+1);
  eattrs16.name_len = strlen(eattrs16.name);

  KECho_syscall_echo((void *) &eattrs16);

  return eattrs16.sink_handle;
}

EChannel EChannel_derive (
EControlContext ec,
char *chan_id,
char *event_filter)
{
  char *name = "EChannel_derive";

  eattrs17.ec = ec;
  memcpy((void *)&eattrs17.chan_id, chan_id, strlen(chan_id));
  memcpy((void *)&eattrs17.event_filter, event_filter, strlen(event_filter));
  memcpy((void *)&eattrs17.name, name, strlen(name)+1);
  eattrs17.name_len = strlen(eattrs17.name);

  KECho_syscall_echo((void *) &eattrs17);

  return eattrs17.chan;
}

EChannel EChannel_typed_derive (
EControlContext ec,
char *chan_id,
char *event_filter,
IOFieldList field_list,
CMFormatList format_list)
{
  char *name = "EChannel_typed_derive";

  eattrs18.ec = ec;
  memcpy((void *)&eattrs18.chan_id, chan_id, strlen(chan_id));
  memcpy((void *)&eattrs18.event_filter, event_filter, strlen(event_filter));
  eattrs18.field_list = field_list;
  memcpy((void *)&eattrs18.name, name, strlen(name)+1);
  eattrs18.name_len = strlen(eattrs18.name);

  KECho_syscall_echo((void *) &eattrs18);

  return eattrs18.chan;
}

ECDataHandle EChannel_data_open (
EChannel channel,
IOFieldList data_field_list,
CMFormatList data_subformat_list)
{
  char *name = "EChannel_data_open";

  eattrs19.chan = channel;
  eattrs19.field_list = data_field_list;
  eattrs19.format_list = data_subformat_list;
  memcpy((void *)&eattrs19.name, name, strlen(name)+1);
  eattrs19.name_len = strlen(eattrs19.name);

  KECho_syscall_echo((void *) &eattrs19);

  return eattrs19.data_handle;
}

void EChannel_data_update (
ECDataHandle data_handle,
void *data)
{
  char *name = "EChannel_data_update";

  eattrs20.data_handle = data_handle;
  eattrs20.data = data;
  memcpy((void *)&eattrs20.name, name, strlen(name)+1);
  eattrs20.name_len = strlen(eattrs20.name);

  KECho_syscall_echo((void *) &eattrs20);
}

EChannel ECproto_derive_periodic (
EControlContext ec,
char *proto_id,
char *filter_function,
IOFieldList field_list,
CMFormatList format_list,
int microsec_period)
{
  char *name = "ECproto_derive_periodic";

  eattrs21.ec = ec;
  memcpy((void *)&eattrs21.proto_id, proto_id, strlen(proto_id));
  memcpy((void *)&eattrs21.filter_function, filter_function, 
	strlen(filter_function)+1);
  eattrs21.field_list = field_list;
  eattrs21.format_list = format_list;
  eattrs21.period = microsec_period;
  memcpy((void *)&eattrs21.name, name, strlen(name)+1);
  eattrs21.name_len = strlen(eattrs21.name);

  KECho_syscall_echo((void *) &eattrs21);

  return eattrs21.chan;
}

#endif
#endif
